import { SyncHook } from '@antv/async-hook';
import { IClusterOptions, IParserCfg, IParserData, ISource, ISourceCFG, ITransform } from '@antv/l7-core';
import { BBox } from '@turf/helpers';
import { EventEmitter } from 'eventemitter3';
export default class Source extends EventEmitter implements ISource {
    data: IParserData;
    extent: BBox;
    hooks: {
        init: SyncHook;
    };
    parser: IParserCfg;
    transforms: ITransform[];
    cluster: boolean;
    clusterOptions: Partial<IClusterOptions>;
    private readonly mapService;
    private invalidExtent;
    private dataArrayChanged;
    private originData;
    private rawData;
    private cfg;
    private clusterIndex;
    constructor(data: any | ISource, cfg?: ISourceCFG);
    setData(data: any, options?: ISourceCFG): void;
    getClusters(zoom: number): any;
    getClustersLeaves(id: number): any;
    updateClusterData(zoom: number): void;
    getFeatureById(id: number): unknown;
    updateFeaturePropertiesById(id: number, properties: Record<string, any>): void;
    getFeatureId(field: string, value: any): number | undefined;
    destroy(): void;
    private caculClusterExtent;
    private initCfg;
    private excuteParser;
    /**
     * 数据统计
     */
    private executeTrans;
    private initCluster;
    private init;
}
